diff -Nur zebra-0.93b/lib/zebra.h zebra-0.93b-new/lib/zebra.h
--- zebra-0.93b/lib/zebra.h	2002-06-22 00:09:21.000000000 +0200
+++ zebra-0.93b-new/lib/zebra.h	2003-11-18 09:58:26.000000000 +0100
@@ -47,8 +47,8 @@
 #endif /* HAVE_SYS_SELECT_H */
 #include <sys/stat.h>
 #include <sys/time.h>
-#include <sys/types.h>
 #include <sys/param.h>
+#include <sys/types.h>
 #ifdef HAVE_SYS_SYSCTL_H
 #include <sys/sysctl.h>
 #endif /* HAVE_SYS_SYSCTL_H */
diff -Nur zebra-0.93b/zebra/ioctl.c zebra-0.93b-new/zebra/ioctl.c
--- zebra-0.93b/zebra/ioctl.c	2001-10-23 10:31:29.000000000 +0200
+++ zebra-0.93b-new/zebra/ioctl.c	2003-11-18 10:06:37.000000000 +0100
@@ -21,6 +21,7 @@
  */
 
 #include <zebra.h>
+#include <netinet/in.h>
 
 #include "linklist.h"
 #include "if.h"
@@ -389,7 +390,7 @@
 #ifdef HAVE_IPV6
 
 #ifdef LINUX_IPV6
-#ifndef _LINUX_IN6_H
+#if !defined(_LINUX_IN6_H) && (!defined(_NETINET_IN_H) || !defined(__dietlibc__))
 /* linux/include/net/ipv6.h */
 struct in6_ifreq 
 {
diff -Nur zebra-0.93b/zebra/rt_ioctl.c zebra-0.93b-new/zebra/rt_ioctl.c
--- zebra-0.93b/zebra/rt_ioctl.c	2001-08-27 10:47:23.000000000 +0200
+++ zebra-0.93b-new/zebra/rt_ioctl.c	2003-11-18 10:10:32.000000000 +0100
@@ -341,7 +341,7 @@
 
 #include <asm/types.h>
 
-#if defined(__GLIBC__) && __GLIBC__ >= 2 && __GLIBC_MINOR__ >= 1
+#if (defined(__GLIBC__) && __GLIBC__ >= 2 && __GLIBC_MINOR__ >= 1) || defined(__dietlibc__)
 /* struct in6_rtmsg will be declared in net/route.h. */
 #else
 #include <linux/ipv6_route.h>
